--- src/VBox/Main/src-client/ConsoleImpl.cpp.orig	2021-03-27 01:43:21 UTC
+++ src/VBox/Main/src-client/ConsoleImpl.cpp
@@ -8801,6 +8801,18 @@ DECLCALLBACK(void) Console::i_vmstateChangeCallback(PU
 
     switch (enmState)
     {
+        case VMSTATE_POWERING_ON:
+        {
+#ifdef VBOX_WITH_GUEST_PROPS
+            Bstr bstr;
+            that->mMachine->COMGETTER(Name)(bstr.asOutParam());
+            that->mMachine->SetGuestProperty(Bstr("/VirtualBox/VirtualMachine/Name").raw(),
+                                             bstr.raw(),
+                                             Bstr("TRANSIENT, RDONLYGUEST").raw());
+            that->mMachine->SaveSettings();
+#endif
+            break;
+        }
         /*
          * The VM has terminated
          */
